#include "lineeditdialog.h"
#include "ui_lineeditdialog.h"

LineEditDialog::LineEditDialog(QWidget *parent, QString label, int length,
                               QString value, QString placeholder) :
    QDialog(parent),
    ui(new Ui::LineEditDialog)
{
    ui->setupUi(this);
    ui->label->setText(label);
    if (length > 0)
        ui->lineEdit->setMaxLength(length);
    ui->lineEdit->setText(value);
    ui->lineEdit->setPlaceholderText(placeholder);

    connect(this, &LineEditDialog::accepted,
            this, [this]() {emit submit(ui->lineEdit->text());});
}

LineEditDialog::~LineEditDialog()
{
    delete ui;
}
