/*
  device.h

  Copyright (c) 2022 Kevin Matz (kevin.matz@gmail.com)

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
  */
#pragma once

#include "packet.h"

namespace ARTNET {

/**
 * @brief The Device class is the base class for ARTNET::Controller
 * and ARTNET::Node
 */
class Device
{
public:
  explicit Device();

//  virtual void receive(ACN::PDU::Stream);

protected:
//  void send(const uint32_t vector, const std::shared_ptr<packet_data> data,
//            const ACN::SDT::UDP::ipAddress&);

  virtual void rxArtPoll();
  virtual void txArtPollReply(std::shared_ptr<ArtPoll> = nullptr);
  virtual void txArtDiagData();
  virtual void rxArtTimeCode();
  virtual void txArtTimeCode();
  virtual void rxArtCommand();
  virtual void txArtCommand();
  virtual void rxArtTrigger();
  virtual void txArtTrigger();
  virtual void rxArtDmx();
  virtual void txArtDmx();
  virtual void rxArtNzs();
  virtual void txArtNzs();
  virtual void rxArtVlc();
  virtual void txArtVlc();
  virtual void rxArtRdm();
  virtual void txArtRdm();
  virtual void rxArtRdmSub();
  virtual void txArtRdmSub();
};

} // namespace ARTNET
